#include <qthing>

#include "esp_log.h"

#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/semphr.h"


#include "SiliconTorch/FxCyanF.hpp"

#include <SpiderLib.hpp>


#include "SiliconTorch/NVSExplorer.hpp"

#include "SiliconTorch/SiliconTorch.hpp"

#include "SiliconTorch/Service/FxCyanF.hpp"
#include "SiliconTorch/Service/Service.hpp"
#include "SiliconTorch/Service/ServiceManager.hpp"





SiliconTorch::SiliconTorch* torch                 = NULL;

SiliconTorch::ServiceManager::Service* fxCyan     = NULL;
SiliconTorch::ServiceManager::ServiceManager* mgr = NULL;


// #include "SiliconTorch/Hardware/AS3935.hpp"
#include "SiliconTorch/Hardware/MAX31856.hpp"




void device_main() {


  qthing::Config cfg;

  // Needed for packet parsing, animation rendering and stuff
  qthing::power_managment_max_power();


  constexpr u8 MISO = 17;
  constexpr u8 MOSI = 16;
  constexpr u8 SCLK = 27;
  constexpr u8 CS   = 26;

  MAX31856::MAX31856* temp = new MAX31856::MAX31856(MISO, MOSI, SCLK, CS);

  //temp->mainLoop();





  /*
  AS3935::AS3935* thunder = new AS3935::AS3935(27, 26, 14, 0x02);

  thunder->calibrateRCO();

  thunder->displayLCO();

  return;


  u8 value = 0x0FF;

  bool result = thunder->i2cReadByte(0x01, &value);
  ESP_LOGI("Thunder", "Reading register[ 0x%02X ] = 0x%02X  ~~>  %s", 0x01, value, result ? "true" : "false");


  result = thunder->i2cWriteByte(0x01, 0xAA);
  ESP_LOGI("Thunder", "Writing register[ 0x%02X ] = 0xAA  ~~>  %s", 0x01, result ? "true" : "false");

  result = thunder->i2cReadByte(0x01, &value);
  ESP_LOGI("Thunder", "Reading register[ 0x%02X ] = 0x%02X  ~~>  %s", 0x01, value, result ? "true" : "false");


  result = thunder->i2cWriteByte(0x01, 0x55);
  ESP_LOGI("Thunder", "Writing register[ 0x%02X ] = 0x55  ~~>  %s", 0x01, result ? "true" : "false");

  result = thunder->i2cReadByte(0x01, &value);
  ESP_LOGI("Thunder", "Reading register[ 0x%02X ] = 0x%02X  ~~>  %s", 0x01, value, result ? "true" : "false");

  */




  torch = new SiliconTorch::SiliconTorch();

  // return;

  SemaphoreHandle_t mutex000 = xSemaphoreCreateBinary();

  // Do it in another task do control stack size
  new SpiderLib::Util::LambdaTask([&]() {
    // Trigger singleton initialization
    SiliconTorch::NVSExplorer::NVSExplorer::instance();


    mgr = new SiliconTorch::ServiceManager::ServiceManager();


    xSemaphoreGive(mutex000);
  });

  xSemaphoreTake(mutex000, portMAX_DELAY);  // avoid races with MQTT subscriptions (TODO: do we lock with WLAN atm???)

  qthing::enable_wifi();
  return;





  /*


  SemaphoreHandle_t mutex = xSemaphoreCreateBinary();

  // Do it in another task do control stack size
  new SpiderLib::Util::LambdaTask([&]() {
    // Trigger singleton initialization
    SiliconTorch::NVSExplorer::NVSExplorer::instance();

    SiliconTorch::FxCyanF::configureFromNVS();

    xSemaphoreGive(mutex);
  });

  xSemaphoreTake(mutex, portMAX_DELAY);  // avoid races with MQTT subscriptions (TODO: do we lock with WLAN atm???)


  */


  qthing::enable_wifi();
  return;




  // #############################
  // ### CLC-Drucker init code ###
  // #############################


/*
  ctrl = new CyanLight::CyanLightControl(3);

  // TODO: As CyanLight:: -NameSpace is now gone we have to add the used GPIOs ourselfs if we ever want to use this snipped again…
  
  ctrl->setFrqRes(100, 19);


  for (u8 i = 0; i < 100; i++) {

    bool _f = i % 2 == 0;

    ctrl->setPWM(0,  _f      * 1.0f);
    ctrl->setPWM(2, (_f ^ 1) * 1.0f);

    vTaskDelay(50 / portTICK_PERIOD_MS);
  }


  ctrl->setPWM(0, 0.0f);
  ctrl->setPWM(1, 0.0f);
  ctrl->setPWM(2, 1.0f);


  qthing::enable_wifi();
  cfg.apply();

  return;
*/


  // ### end CLC-Drucker ###
  // #############################

}
